#include <stdio.h>
#include <stdlib.h>
#include <math.h>

typedef enum {integer, real, string} Type;

int freadline(Type t, FILE *f, char *b, int size)
{int i;
 char *e;
 b[0]=0;
 fgets(b,size,f);
 for (i=0;i<size&&b[i]&&b[i]!='\n';i++);
 b[i]=0;
 switch (t)
 {case string:return 1;
  case integer:{strtol(b,&e,10);
		return *b&&!*e;
	       }
  case real:{strtod(b,&e);
	     return *b&&!*e;
	    }
 }
 return 0;
}

int eqDoubles(double d1, double d2, int dig)
{int i;
 for (i=1;i<=dig;i++) {d1*=10;d2*=10;}
 return floor(d1+0.5)==floor(d2+0.5);
}

int main(int argc, char *argv[])
{FILE *f;
 double comp1,comp2,sol1,sol2;
 int points=0,line1f,line2f;
 char buf[32], *e;
 if (argc!=4)
 {printf("Argument error\n");
  return 0;
 }
 if (!(f = fopen(argv[3], "r")))      // solution file
 {printf("Cannot open solution.\n");
  return 0;
 }
 if (!freadline(real,f,buf,30))
 {printf("Wrong solution file.\n");
  fclose(f);
  return 0;
 }
 sol1=strtod(buf, &e);
 if (!freadline(real,f,buf,30))
 {printf("Wrong solution file.\n");
  fclose(f);
  return 0;
 }
 sol2=strtod(buf, &e);
 fclose(f);
 if (!(f = fopen(argv[2], "r")))    // competitor file
 {printf("0\nCannot open result.\n");
  fclose(f);
  return 0;
 }
 line1f=!freadline(real,f,buf,30);
 if (!line1f)
 {comp1=strtod(buf, &e);
  if (eqDoubles(sol1,comp1,2)) points+=5;
  else if (eqDoubles(sol1,comp1,1)) points+=2;
 }
 line2f=!freadline(real,f,buf,30);
 if (!line2f)
 {comp2=strtod(buf, &e);
  if (eqDoubles(sol2,comp2,2)) points+=5;
  else if (eqDoubles(sol2,comp2,1)) points+=3;
 }
 fclose(f);
 printf("%d\n",points);
 if (points==10)
 {printf("Correct solution.\n");
 return 0;}
 if (line1f) printf("Incorrect first line format.\n");
 else {if (eqDoubles(sol1,comp1,2)) printf("Correct first walk.\n");
       else {if (eqDoubles(sol1,comp1,1)) printf("Nearly correct first walk.\n");
	     else printf("Incorrect first walk.\n");
	    }
      }
 if (line2f) printf("Incorrect second line format.\n");
 else {if (eqDoubles(sol2,comp2,2)) printf("Correct second walk.\n");
       else {if (eqDoubles(sol2,comp2,1)) printf("Nearly correct second walk.\n");
	     else printf("Incorrect second walk.\n");
	    }
      }
 return 0;
}