#include <iostream>
#include <fstream>

using namespace std;

int main(int argc, char *argv[])
{

   if (argc != 4)
   { cout << "Argument error \n";
     return 0;
   }

   ifstream fin(argv[1]);    // input file
   if(fin.fail())
   { cout << 0 << endl;
     cout << "Cannot open input file " << argv[1] << endl;
     return 0;
   }

   ifstream fout(argv[2]);    // output file
   if(fout.fail())
   { cout << 0 << endl;
     cout << "Cannot open output file " << argv[2] << endl;
     return 0;
   }

   ifstream fsol(argv[3]);    // solution file
   if(fsol.fail())
   { cout << 0 << endl;
     cout << "Cannot open solution file " << argv[3] << endl;
     return 0;
   }

   string studAns, solAns;
   fout >> studAns;
   fsol >> solAns;
   if(studAns!=solAns)
   { fin.close();
     fout.close();
     fsol.close();
     cout << 0 << endl;
     cout << "Wrogn output \n";
     cout << studAns << " != " << solAns << endl;
     return 0;
   }

   if(studAns==solAns && solAns=="NO")
   { fin.close();
     fout.close();
     fsol.close();
     cout << 10 << endl;
     cout << "Correct solution \n";
     return 0;
   }
   fout.close();
   fsol.close();

   int a[128][128];
   int m,n,k,s;
   int u,v,i,j;

   fin >> m >> n >> k;
   for(i=0; i<=m; i++)
   for(j=0; j<=n; j++)
     a[i][j]=0;

   for(i=1; i<=k; i++)
   { fin >> u >> v;
     a[u][v]=1;
   }
   fin.close();

   fout.open(argv[2]);
   fout >> s;
   if(s!=(k-2*m))
   { fout.close();
     cout << 0 << endl;
     cout << "Wrogn output \n";
     cout << "s != k-2*m" << endl;
     return 0;
   }

   for(i=1; i<=s; i++)
   { fout >> u >> v;
     if(a[u][v]==0)
     { fout.close();
       cout << 0 << endl;
       cout << "Wrogn output \n";
       cout << "There in no path " << u << "-" << v << endl;
       return 0;
     }
     a[u][v]=0;
   }
   fout.close();

   for(i=1; i<=m; i++)
   { s=0;
     for(j=1; j<=n; j++)
     if(a[i][j]==1) s++;
     if(s!=2)
     { cout << 0 << endl;
       cout << "Wrogn output \n";
       cout << "A[" << i << "] is connected to " << s << " points from B\n";
       return 0;
     }
   }

   for(j=1; j<=n; j++)
   { s=0;
     for(i=1; i<=m; i++)
     if(a[i][j]==1) s++;
     if(s>1)
     { cout << 0 << endl;
       cout << "Wrogn output \n";
       cout << "B[" << j << "] is connected to " << s << " points from A\n";
       return 0;
     }
   }

   cout << 10 << endl;
   cout << "Correct solution \n";

}


